
/* -----------------------------------------------------------------------
MAIN.C
MidiShare tutorial main module.

(c) Grame 1995
--------------------------------------------------------------------------*/

#ifndef __MidiShare__
#include "mshare.h"
#endif

#ifndef __WINDOWS_H
#include <windows.h>
#endif

#ifndef __MSTUTORIAL__
#include "tutorial.h"
#endif

#include <string.h>
#include <toolhelp.h>

/* -----------------------------------------------------------------------*/
/* TEST FUNCTION PROTOTYPES														  */
/* -----------------------------------------------------------------------*/
void test1(void);
void test2(void);
void test3(void);
void test4(void);
void test5(void);
void test6(void);
void test7(void);
void test8(void);
void test9(void);
void test10(void);
void test11(void);
void test12(void);
void test13(void);
void test14(void);
void test15(void);
void test16(void);
void test17(void);
void test18(void);
void test19(void);
void test20(void);
void test21(void);
void test22(void);
void Welcome(void);

/* -----------------------------------------------------------------------*/
/* VARIABLES															  */
/* -----------------------------------------------------------------------*/
extern short ourRefNum;
static TestFctnPtr tbl[] = {
									test1, test2, test3, test4, test5, test6, test7,
									test8, test9, test10, test11, test12, test13,
									test14, test15, test16, test17, test18, test19,
									test20, test21, test22, 0 };
TAppl FAR gAppl;

/* -----------------------------------------------------------------------*/
/* FUNCTIONS PROTOTYPES                                   */
/* -----------------------------------------------------------------------*/
Boolean NEAR 	AlertUser(HWND hWnd, char *title, char *message);
void 				TutorialMain(TApplPtr appl);
void pr (char *s,...);
BOOL FAR PASCAL _export DebugDlgProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
BOOL FAR PASCAL _export AboutDlgProc(HWND hDlg,UINT message,UINT wParam,LONG lParam);
void DebugStr(char *s);

/* -----------------------------------------------------------------------*/
/* APPLICATION ENTRY POINT                            */
/* -----------------------------------------------------------------------*/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
			LPSTR lpszCmdLine, int nCmdShow)
{
	if ( hPrevInstance ) return FALSE ;
	gAppl.appInstance= hInstance;
	DialogBox(hInstance, "msTutorial", NULL,
				(DLGPROC)MakeProcInstance(msTutorialDlgProc,hInstance));
	MidiClose(ourRefNum);
	return 1;
}

/* -----------------------------------------------------------------------*/
/* INITIALIZATION                     */
/* -----------------------------------------------------------------------*/
BOOL Initialize (TApplPtr appl, HWND hDlg)
{
	appl->hDlg = hDlg;
	appl->debugMess= 0;
	appl->debugWindowXpos = 0;
	appl->debugWindowYpos = 0;
	appl->debugWindowMoved = 0;

	appl->ftbl = tbl ;
	appl->TestIndice = 0 ;
	appl->exit = appl->running = false;
	appl->AboutDlgProcInst=	(DLGPROC)MakeProcInstance(AboutDlgProc,appl->appInstance);
	appl->DebugDlgProcInst=	(DLGPROC)MakeProcInstance(DebugDlgProc,appl->appInstance);

	Welcome();
   return TRUE;
}

/* -----------------------------------------------------------------------*/
/* MAIN DIALOG PROC                      */
/* -----------------------------------------------------------------------*/
BOOL FAR PASCAL _export msTutorialDlgProc(HWND hDlg,UINT message,
					 UINT wParam,LONG lParam)
{
	TApplPtr appl;

	appl= &gAppl;
	switch (message) {
		case WM_INITDIALOG:
			return Initialize (appl, hDlg);

		case WM_COMMAND :
			switch(wParam) {
				case GO :
					if (appl->running) {
						SetDlgItemText(hDlg,GO, "Start");
						MidiClose(ourRefNum);
						appl->TestIndice = 21;
						EndDialog(appl->debughDlg,TRUE);
					}
					else {
						SetDlgItemText(hDlg,GO, "Stop");
						appl->TestIndice = 0;
						TutorialMain(appl);
					}
					break;

				case AboutButton :
					EnableWindow(GetDlgItem(appl->hDlg,AboutButton),false);
					DialogBox(appl->appInstance, "AboutDlg", hDlg, appl->AboutDlgProcInst);
					break;

				case IDD_QUITTER :
					appl->TestIndice = 21 ;
					appl->exit= TRUE;
					if (appl->debughDlg) EndDialog(appl->debughDlg,TRUE);
					EndDialog(hDlg,TRUE);
					break;
			}
			break;
	}
	return FALSE ;
}

/* ---------------------------------------------------------------------- */
Boolean NEAR AlertUser(HWND hWnd, char *title, char *message)
{
	UINT style= MB_OK|MB_ICONSTOP;

	MessageBox (hWnd, message, title, style);
	SendMessage(hWnd, WM_SYSCOMMAND, SC_CLOSE,0L);
	return false;
}

/* -----------------------------------------------------------------------*/
void DebugStr(char *s)
{
	TApplPtr appl;

	appl= &gAppl;
	appl->debugMess= &s[6];
	DialogBox(appl->appInstance, "DebugDlg", NULL, appl->DebugDlgProcInst);
}

/* -----------------------------------------------------------------------*/
/* Printing messages in the main window											  */
/* -----------------------------------------------------------------------*/
void pr(char *s,...)
{
	char buff[120], *ptr;
	long *args, a1, a2, a3, a4;
	static LRESULT i=0;

	args= (long *)&s;
	args++;
	a1= *args++;
	a2= *args++;
	a3= *args++;
	a4= *args++;
	wsprintf(buff, s, a1, a2, a3, a4);
	ptr= buff;
	while (*ptr) {
		if (*ptr== '\n') {
			*ptr++= ' ';
			if (*ptr) pr("");
		}
		else ptr++;
	}
	i= SendDlgItemMessage(gAppl.hDlg,display,LB_ADDSTRING,0,(LPARAM)buff);
	SendDlgItemMessage(gAppl.hDlg, display, LB_SETSEL, FALSE, MAKELPARAM(i-1,0));
	SendDlgItemMessage(gAppl.hDlg, display, LB_SETSEL, TRUE, MAKELPARAM(i,0));
	SendDlgItemMessage(gAppl.hDlg, display, LB_SETTOPINDEX,(WORD)i,0L);
}

/* -----------------------------------------------------------------------*/
/* DEBUG DIALOG                                    */
/* -----------------------------------------------------------------------*/
BOOL FAR PASCAL _export DebugDlgProc(HWND hDlg,UINT message,
													UINT wParam,LONG lParam)
{
	TApplPtr appl;

	appl= &gAppl;
	switch (message) {
		case WM_INITDIALOG:
			if (appl->debugWindowMoved) {
				SetWindowPos(hDlg,HWND_TOP,appl->debugWindowXpos,
						appl->debugWindowYpos,0,0,SWP_NOSIZE);
			}
			SetDlgItemText(hDlg,DebugLine,appl->debugMess);
			appl->debughDlg = hDlg ;
			return TRUE ;

		case WM_COMMAND:
			switch(wParam) {
				case IDOK:
					EndDialog(hDlg,0);
					break;
			}
			break;
		case WM_MOVE:
			appl->debugWindowXpos = LOWORD(lParam)-5;
			appl->debugWindowYpos = HIWORD(lParam)-24;
			appl->debugWindowMoved = TRUE ;
			break;
	}
	return FALSE ;
}


void Welcome(void)
{
  pr("      <<< WELCOME TO THE MIDISHARE TUTORIAL >>>");
  pr(" ");
  pr("In order for you to look at the source code and ");
  pr("understand how MidiShare works, you may print the");
  pr("'tutorial.c' file before running.");
  pr(" ");
}

/* -----------------------------------------------------------------------*/
/* Tutorial main entry point                                    */
/* -----------------------------------------------------------------------*/
void TutorialMain(TApplPtr appl)
{
  TestFctnPtr fctn;

  appl->running = true;
  while (fctn = appl->ftbl[appl->TestIndice]) {
	  fctn();
	  appl->TestIndice++;
  }
  SetDlgItemText(appl->hDlg, GO,"Start");
  pr(" ");
  pr("-------------------------------------------------------");
  pr("    The MidiShare Tutorial is set back to test #1      ");
  pr("    use the command start to re-enter the tutorial     ");
  pr("-------------------------------------------------------");
  pr(" ");
  appl->running = false;
}


BOOL FAR PASCAL _export AboutDlgProc(HWND hDlg,UINT message,
													UINT wParam,LONG lParam)
{
	TApplPtr appl;
	char buff[10];
	short version;

	appl= &gAppl;
	switch (message) {
		case WM_INITDIALOG :
			appl->abouthDlg = hDlg ;
			version = MidiGetVersion();
			wsprintf(buff,"%d.%d", version/100, version%100);
			SetDlgItemText(hDlg, Version, buff);
			return TRUE ;

		case WM_COMMAND :
			if(wParam == IDOK) {
				EnableWindow(GetDlgItem(appl->hDlg,AboutButton),true);
				EndDialog(hDlg,0);
			}
			break;
	}
	return FALSE ;
}



